'mIRC Ascii art editor v1.0
'Created by Aaron Gover
'agover@midmich.cc.mi.us
'Read the docs.

DECLARE SUB DisplayUpDown ()
DECLARE SUB DisplayLeftRight ()
DECLARE SUB ChangeArt ()
DECLARE SUB DisplayHUD ()
DECLARE SUB DrawOnScreen ()
DECLARE SUB LoadInProgress (LoadFile$)
DECLARE SUB CommandParse (Com$)
DECLARE SUB SaveInProgress (SaveFile$)
DECLARE SUB DisplayWarning (Warning$)
DECLARE SUB CreateFrame ()
DECLARE SUB DisplayFrame ()
DECLARE SUB DisplayArt ()
DECLARE SUB SaveFinal (SaveFile$)
DECLARE SUB ClearScreen ()
DECLARE SUB InitializeArt ()
DECLARE FUNCTION ToggleValue! (InValue AS INTEGER)
DECLARE FUNCTION GetNewChar$ ()
DECLARE FUNCTION IncrementLoop! (Current AS INTEGER, Max AS INTEGER, Min AS INTEGER, NumStep AS INTEGER)
DECLARE FUNCTION GetArtHeight! ()
DECLARE FUNCTION BrushUpDown$ ()
DECLARE FUNCTION PaintStatus$ ()
DECLARE FUNCTION GetArtWidth! ()
DECLARE FUNCTION GetFileName$ (Extention$, Reason$)
DECLARE FUNCTION OutCol$ (InCol AS INTEGER)
DECLARE FUNCTION FileNameGood! (FileName$)
DECLARE FUNCTION FileExists (FileName$)

CONST AbsMaxScreenWidth = 70
CONST AbsMaxScreenHeight = 15
CONST MinScreenWidth = 1
CONST MinScreenHeight = 1


CONST mIRCpath$ = "C:\mirc\"
   'this path tells the program where mIRC is.

CONST Layers = 3
   CONST ForeColor = 1
   CONST BackColor = 2
   CONST AsciiChar = 3

CONST ColorStart$ = ""
CONST ColorStop$ = ""

CONST DispForeColor = 15
CONST DispBackColor = 0
CONST DispInfoColor = 14
   'The Preceding three constants are the display colors. You can change
   'them if you`d like

DIM SHARED IsSaved AS INTEGER
   'Tells the program whether work has been saved
DIM SHARED Quit AS INTEGER
DIM SHARED mIRCcolors(0 TO 15) AS INTEGER
DIM SHARED Art(1 TO AbsMaxScreenWidth, 1 TO AbsMaxScreenHeight, 1 TO Layers) AS INTEGER
DIM SHARED CursorLocation(1 TO 2) AS INTEGER
DIM SHARED BrushStatus(1 TO 5) AS INTEGER
   '1 is the up(0)/down(1) varible
   '2 is the brush status (Color Only(1), Character Only(2), Both(3))
   '3 is the current Foreground Color
   '4 is the current Background Color
   '5 is the current Character

DIM SHARED ArtFrame$(1 TO 3)
DIM SHARED MaxScreenWidth AS INTEGER
DIM SHARED MaxScreenHeight AS INTEGER

DisplayWarning ("Please be sure NumLock is on!")
InitializeArt
ClearScreen

WHILE NOT QuitNow = 1
   CreateFrame
   DisplayFrame
   DisplayArt
   DisplayHUD
   ComQ$ = INKEY$
   CommandParse (ComQ$)
   IF ComQ$ = "q" THEN QuitNow = 1
   ChangeArt
   
  
WEND

FUNCTION BrushUpDown$
   BrushUpDown$ = "Error"
   IF BrushStatus(1) = 0 THEN BrushUpDown$ = "Up"
   IF BrushStatus(1) = 1 THEN BrushUpDown$ = "Down"
END FUNCTION

SUB ChangeArt
   '1 is the up(0)/down(1) varible
   '2 is the brush status (Color Only(1), Character Only(2), Both(3))
   '3 is the current Foreground Color
   '4 is the current Background Color
   '5 is the current Character
   IF BrushStatus(1) = 1 THEN
      IF BrushStatus(2) = 1 THEN
         Art(CursorLocation(1), CursorLocation(2), ForeColor) = BrushStatus(3)
         Art(CursorLocation(1), CursorLocation(2), BackColor) = BrushStatus(4)
      END IF

      IF BrushStatus(2) = 2 THEN
         Art(CursorLocation(1), CursorLocation(2), AsciiChar) = BrushStatus(5)
      END IF

      IF BrushStatus(2) = 3 THEN
         Art(CursorLocation(1), CursorLocation(2), ForeColor) = BrushStatus(3)
         Art(CursorLocation(1), CursorLocation(2), BackColor) = BrushStatus(4)
         Art(CursorLocation(1), CursorLocation(2), AsciiChar) = BrushStatus(5)
      END IF
      
      'Tell Program that art has changed since last save
         IsSaved = 0
      DrawOnScreen
   END IF
END SUB

SUB ClearScreen
   COLOR DispForeColor, DispBackColor
   CLS
END SUB

SUB CommandParse (Com$)
   'This Sub takes the command and decides what to do with it.


   'Directional Keys -- Make Sure Numlock is ON
   IF Com$ = "7" THEN
      CursorLocation(1) = IncrementLoop(CursorLocation(1), MaxScreenWidth, MinScreenWidth, -1)
      CursorLocation(2) = IncrementLoop(CursorLocation(2), MaxScreenHeight, MinScreenHeight, -1)
   END IF

   IF Com$ = "9" THEN
      CursorLocation(1) = IncrementLoop(CursorLocation(1), MaxScreenWidth, MinScreenWidth, 1)
      CursorLocation(2) = IncrementLoop(CursorLocation(2), MaxScreenHeight, MinScreenHeight, -1)
   END IF

   IF Com$ = "1" THEN
      CursorLocation(1) = IncrementLoop(CursorLocation(1), MaxScreenWidth, MinScreenWidth, -1)
      CursorLocation(2) = IncrementLoop(CursorLocation(2), MaxScreenHeight, MinScreenHeight, 1)
   END IF

   IF Com$ = "3" THEN
      CursorLocation(1) = IncrementLoop(CursorLocation(1), MaxScreenWidth, MinScreenWidth, 1)
      CursorLocation(2) = IncrementLoop(CursorLocation(2), MaxScreenHeight, MinScreenHeight, 1)
   END IF

   IF Com$ = "4" THEN
      CursorLocation(1) = IncrementLoop(CursorLocation(1), MaxScreenWidth, MinScreenWidth, -1)
   END IF

   IF Com$ = "6" THEN
      CursorLocation(1) = IncrementLoop(CursorLocation(1), MaxScreenWidth, MinScreenWidth, 1)
   END IF

   IF Com$ = "8" THEN
      CursorLocation(2) = IncrementLoop(CursorLocation(2), MaxScreenHeight, MinScreenHeight, -1)
   END IF

   IF Com$ = "2" THEN
      CursorLocation(2) = IncrementLoop(CursorLocation(2), MaxScreenHeight, MinScreenHeight, 1)
   END IF
  
   'Changing the Foreground Color...
   IF Com$ = "-" THEN BrushStatus(3) = IncrementLoop(BrushStatus(3), 15, 0, -1)
   IF Com$ = "+" THEN BrushStatus(3) = IncrementLoop(BrushStatus(3), 15, 0, 1)

   'Changing the Background Color...
   IF Com$ = "/" THEN BrushStatus(4) = IncrementLoop(BrushStatus(4), 15, 0, -1)
   IF Com$ = "*" THEN BrushStatus(4) = IncrementLoop(BrushStatus(4), 15, 0, 1)

   'Changing the AsciiChar...
   IF Com$ = "," THEN BrushStatus(5) = IncrementLoop(BrushStatus(5), 127, 0, -1)
   IF Com$ = "." THEN BrushStatus(5) = IncrementLoop(BrushStatus(5), 127, 0, 1)
   IF Com$ = "?" THEN BrushStatus(5) = ASC(GetNewChar$)
      
   'Changing the PaintStatus...
   IF Com$ = "a" THEN BrushStatus(2) = IncrementLoop(BrushStatus(2), 3, 1, 1)

   'Save a Work-in-progress
   IF Com$ = "!" THEN SaveInProgress (GetFileName$("mrc", "Saving"))

   'Toggle Brush Up/Down
   IF Com$ = "z" THEN BrushStatus(1) = ToggleValue(BrushStatus(1))

   'Load a Work-in-progress
   IF Com$ = "@" THEN LoadInProgress (GetFileName$("mrc", "Loading"))

   'Save a FINAL version!
   IF Com$ = "#" THEN SaveFinal (GetFileName$("txt", "use in mIRC"))

END SUB

SUB CreateFrame
   'This SUB creates the *data* for the frame for the art :)
   ArtFrame$(1) = "" + STRING$(MaxScreenWidth, "") + ""
   ArtFrame$(2) = "" + STRING$(MaxScreenWidth, "") + ""
   ArtFrame$(3) = ""
END SUB

SUB DisplayArt
   FOR DisplayX = 1 TO MaxScreenWidth
      FOR DisplayY = 1 TO MaxScreenHeight
         LOCATE (DisplayY + 1), (DisplayX + 1)
         COLOR Art(DisplayX, DisplayY, ForeColor), Art(DisplayX, DisplayY, BackColor)
         PRINT CHR$(Art(DisplayX, DisplayY, AsciiChar))
      NEXT DisplayY
   NEXT DisplayX
  
   COLOR DispForeColor, DispBackColor
    
END SUB

SUB DisplayFrame
   'This SUB Displays the Frame for the art on-screen
   COLOR DispForeColor, DispBackColor
   LOCATE 1, 1
   PRINT ArtFrame$(1)
   LOCATE (2 + MaxScreenHeight), 1
   PRINT ArtFrame$(2)
  
   FOR DispFrameY = 1 TO MaxScreenHeight
      LOCATE (DispFrameY + 1), 1
      PRINT ArtFrame$(3)
      LOCATE (DispFrameY + 1), (MaxScreenWidth + 2)
      PRINT ArtFrame$(3)
   NEXT DispFrameY

END SUB

SUB DisplayHUD

   'Display Cursor Indicators
   DisplayUpDown
   DisplayLeftRight

   'Display The Brush Location
   LOCATE 20, 1
   COLOR DispForeColor, DispBackColor
   PRINT "Brush Location"
   LOCATE 21, 1
   COLOR DispInfoColor, DispBackColor
   PRINT USING "X: ## Y: ##"; CursorLocation(1); CursorLocation(2)

   'Display The Brush
   LOCATE 20, 20
   COLOR DispForeColor, DispBackColor
   PRINT "Brush:";
   COLOR BrushStatus(3), BrushStatus(4)
   PRINT CHR$(BrushStatus(5))

   'Display The Brush Status
   LOCATE 23, 1
   COLOR DispForeColor, DispBackColor
   PRINT "Brush:";
   COLOR DispInfoColor, DispBackColor
   PRINT USING "\          \"; PaintStatus$

   'Display The Brush Status
   LOCATE 23, 20
   COLOR DispForeColor, DispBackColor
   PRINT "Brush is ";
   COLOR DispInfoColor, DispBackColor
   PRINT USING "\    \"; BrushUpDown$

END SUB

SUB DisplayLeftRight
'This Sub displays a "<" to the right of the window at cursor level
   FOR DispX = (MinScreenWidth) TO (MaxScreenWidth)
      LOCATE (MaxScreenHeight + 3), (DispX + 1)
      IF (DispX = CursorLocation(1)) THEN
            COLOR DispInfoColor, DispBackColor
         ELSE
            COLOR DispBackColor, DispBackColor
      END IF
      PRINT "^"
   NEXT DispX
END SUB

SUB DisplayUpDown
'This Sub displays a "<" to the right of the window at cursor level
   FOR DispY = (MinScreenHeight) TO (MaxScreenHeight)
      LOCATE (DispY + 1), (MaxScreenWidth + 3)
      IF (DispY = CursorLocation(2)) THEN
            COLOR DispInfoColor, DispBackColor
         ELSE
            COLOR DispBackColor, DispBackColor
      END IF
      PRINT "<"
   NEXT DispY
END SUB

SUB DisplayWarning (Warning$)

ClearScreen
   BEEP
   XCenter = (40 - INT(LEN(Warning$) / 2))
   LOCATE 12, XCenter
   COLOR 4, 15
   PRINT Warning$
   XCenter = (40 - INT(LEN("[Press any key!]") / 2))
   LOCATE 14, XCenter
   COLOR 7, 0
   PRINT "[Press any key!]"

   DO
   LOOP WHILE INKEY$ = ""

END SUB

SUB DrawOnScreen
      'Draw on-screen
         LOCATE CursorLocation(2) + 1, CursorLocation(1) + 1
         COLOR Art(CursorLocation(1), CursorLocation(2), ForeColor), Art(CursorLocation(1), CursorLocation(2), BackColor)
         PRINT CHR$(Art(CursorLocation(1), CursorLocation(2), AsciiChar))
         COLOR DispForeColor, DispBackColor
END SUB

FUNCTION FileExists (FileName$)
'returns a 1 if the file exists, a 0 if it does not
   'Stores a bare directory readout of precisely that filename to disk
   'If the length of that file is greater than 0, the file exists.
   SHELL "dir " + FileName$ + " /B > " + mIRCpath$ + "TestDir.txt"
   OPEN mIRCpath$ + "TestDir.txt" FOR INPUT AS #1
      IF (LOF(1) > 0) THEN FileExists = 1
   CLOSE #1
   KILL mIRCpath$ + "TestDir.txt"
END FUNCTION

FUNCTION FileNameGood (FileName$)
   'Returns a 0 if the file name is bad, a 1 if it is good.
   Check = 0
   IF (LEN(FileName$) > 8) OR (LEN(FileName$) < 1) THEN Check = 0
   IF (LEN(FileName$) < 9) AND (LEN(FileName$) > 0) THEN Check = 1
   
   IF Check = 1 THEN
      FOR FileChecking = 1 TO (LEN(FileName$))
         IF MID$(FileName$, FileChecking, 1) = "." THEN Check = 0
      NEXT FileChecking
   END IF

   FileNameGood = Check
END FUNCTION

FUNCTION GetArtHeight
   WHILE CheckHeight = 0
      CheckHeight = 1
      ClearScreen
      PRINT "Input the height for your art: (Minimum: 1, Maximum: "; AbsMaxScreenHeight; ")"
      INPUT TestScreenHeight
      IF (AbsMaxScreenHeight < TestScreenHeight) THEN CheckHeight = 0
      IF (1 > TestScreenHeight) THEN CheckHeight = 0
      IF CheckHeight = 0 THEN DisplayWarning ("Not a valid value!")
   WEND

   GetArtHeight = TestScreenHeight

END FUNCTION

FUNCTION GetArtWidth
   WHILE CheckWidth = 0
      CheckWidth = 1
      ClearScreen
      PRINT "Input the width for your art: (Minimum: 1, Maximum: "; AbsMaxScreenWidth; ")"
      INPUT TestScreenWidth
      IF (AbsMaxScreenWidth < TestScreenWidth) THEN CheckWidth = 0
      IF (1 > TestScreenWidth) THEN CheckWidth = 0
      IF CheckWidth = 0 THEN DisplayWarning ("Not a valid value!")
   WEND

   GetArtWidth = TestScreenWidth
END FUNCTION

FUNCTION GetFileName$ (Extention$, Reason$)
   Check = 0

   WHILE Check = 0
      COLOR 15, 0
      CLS
      COLOR DispForeColor, DispBackColor
      PRINT "Enter File Name for ";
      COLOR DispInfoColor, DispBackColor
      PRINT Reason$;
      COLOR DispForeColor, DispBackColor
      PRINT ": [8 Characters Max, No Extention!]"
      INPUT FileName$
      Check = FileNameGood(FileName$)
   WEND

   GetFileName$ = mIRCpath$ + FileName$ + "." + Extention$

END FUNCTION

FUNCTION GetNewChar$
   ClearScreen
   PRINT "Enter new ASCII paintbrush:"
   INPUT PaintBrush$
   GetNewChar$ = MID$(PaintBrush$, 1, 1)
END FUNCTION

FUNCTION IncrementLoop (Current AS INTEGER, Max AS INTEGER, Min AS INTEGER, NumStep AS INTEGER)
   'This Function will increment Current + NumStep, but if that goes over max
   'or under min, it loops around.
   CheckCurrent = Current + NumStep
   IF CheckCurrent > Max THEN CheckCurrent = Min
   IF CheckCurrent < Min THEN CheckCurrent = Max
   IncrementLoop = CheckCurrent
END FUNCTION

SUB InitializeArt
  
   ClearScreen
   MaxScreenWidth = GetArtWidth
   MaxScreenHeight = GetArtHeight
   CreateFrame
  
   'Set the mIRC colors :)
   mIRCcolors(0) = 1
   mIRCcolors(1) = 2
   mIRCcolors(2) = 3
   mIRCcolors(3) = 10
   mIRCcolors(4) = 4
   mIRCcolors(5) = 6
   mIRCcolors(6) = 5
   mIRCcolors(7) = 14
   mIRCcolors(8) = 15
   mIRCcolors(9) = 12
   mIRCcolors(10) = 9
   mIRCcolors(11) = 11
   mIRCcolors(12) = 13
   mIRCcolors(13) = 13
   mIRCcolors(14) = 8
   mIRCcolors(15) = 0

   'Initialize Brush
      BrushStatus(1) = 0
      BrushStatus(2) = 3
      BrushStatus(3) = 0
      BrushStatus(4) = 15
      BrushStatus(5) = 32
      CursorLocation(1) = 1
      CursorLocation(2) = 1

   'Tell program not to quit and that the art is not saved
      QuitNow = 0
      IsSaved = 0

FOR InitArtX = 1 TO MaxScreenWidth
      FOR InitArtY = 1 TO MaxScreenHeight
         Art(InitArtX, InitArtY, ForeColor) = 0
         Art(InitArtX, InitArtY, BackColor) = 15
         Art(InitArtX, InitArtY, AsciiChar) = 32
      NEXT InitArtY
   NEXT InitArtX

END SUB

SUB LoadInProgress (LoadFile$)
    
   IF FileExists(LoadFile$) = 1 THEN
      OPEN LoadFile$ FOR INPUT AS #1
      INPUT #1, MaxScreenWidth, MaxScreenHeight
      FOR SaveY = 1 TO MaxScreenHeight
         FOR SaveX = 1 TO MaxScreenWidth
            INPUT #1, Art(SaveX, SaveY, 1), Art(SaveX, SaveY, 2), Art(SaveX, SaveY, 3)
         NEXT SaveX
      NEXT SaveY

      CLOSE #1
      IsSaved = 1
   ELSE
      DisplayWarning ("File doesn't exist!")
   END IF
END SUB

FUNCTION OutCol$ (InCol AS INTEGER)
'mIRC Color Scheme
'0 white     8 yellow
'1 black     9 lightgreen
'2 blue      10 cyan
'3 green     11 lightcyan
'4 lightred  12 lightblue
'5 brown     13 pink
'6 purple    14 grey
'7 orange    15 lightgrey

   OutCol$ = "0"
   IF InCol = 0 THEN OutCol$ = "0"
   IF InCol = 1 THEN OutCol$ = "1"
   IF InCol = 2 THEN OutCol$ = "2"
   IF InCol = 3 THEN OutCol$ = "3"
   IF InCol = 4 THEN OutCol$ = "4"
   IF InCol = 5 THEN OutCol$ = "5"
   IF InCol = 6 THEN OutCol$ = "6"
   IF InCol = 7 THEN OutCol$ = "7"
   IF InCol = 8 THEN OutCol$ = "8"
   IF InCol = 9 THEN OutCol$ = "9"
   IF InCol = 10 THEN OutCol$ = "10"
   IF InCol = 11 THEN OutCol$ = "11"
   IF InCol = 12 THEN OutCol$ = "12"
   IF InCol = 13 THEN OutCol$ = "13"
   IF InCol = 14 THEN OutCol$ = "14"
   IF InCol = 15 THEN OutCol$ = "15"

END FUNCTION

FUNCTION PaintStatus$
   PaintStatus$ = "Error"
   '2 is the brush status (Color Only(1), Character Only(2), Both(3))
   IF BrushStatus(2) = 1 THEN PaintStatus$ = "Color Only"
   IF BrushStatus(2) = 2 THEN PaintStatus$ = "Char. Only"
   IF BrushStatus(2) = 3 THEN PaintStatus$ = "Normal"
END FUNCTION

SUB SaveFinal (SaveFile$)
'This Sub saves the picture in its final form, ready to be used!

   OPEN SaveFile$ FOR OUTPUT AS #1
  
   FOR SaveY = 1 TO MaxScreenHeight
      LineOut$ = ""
      FOR SaveX = 1 TO MaxScreenWidth
      PrepData$ = ""
      C1$ = OutCol$(mIRCcolors(Art(SaveX, SaveY, ForeColor)))
      C2$ = OutCol$(mIRCcolors(Art(SaveX, SaveY, BackColor)))
      C3 = Art(SaveX, SaveY, AsciiChar)
      PrepData$ = PrepData$ + ColorStart$ + C1$ + "," + C2$ + CHR$(C3) + ColorStop$
      LineOut$ = LineOut$ + PrepData$
      NEXT SaveX
      PRINT #1, LineOut$
   NEXT SaveY

   CLOSE #1
   DisplayWarning ("Use command /play " + SaveFile$ + " to use art!")
   IsSaved = 1
END SUB

SUB SaveInProgress (SaveFile$)
'This Sub saves the picture in a form the program can Also easily load.
  
   OPEN SaveFile$ FOR OUTPUT AS #1
   PRINT #1, MaxScreenWidth, MaxScreenHeight
   FOR SaveY = 1 TO MaxScreenHeight
      FOR SaveX = 1 TO MaxScreenWidth
         PRINT #1, Art(SaveX, SaveY, 1), Art(SaveX, SaveY, 2), Art(SaveX, SaveY, 3)
      NEXT SaveX
   NEXT SaveY

   CLOSE #1
   IsSaved = 1
END SUB

FUNCTION ToggleValue (InValue AS INTEGER)
   IF InValue = 1 THEN ToggleValue = 0
   IF InValue = 0 THEN ToggleValue = 1
END FUNCTION

